;;;
;;; $Header: /home/gene/icfp2001/source/RCS/a.lisp,v 1.4 2001/07/29 09:17:31 gene Exp $
;;;

(defvar *debug* nil "Flag to indicate debugging mode.")

(defun file-exists-p (filename)
  "Returns true if a file exists, false otherwise."
  (with-open-file (file filename :direction :input :if-does-not-exist nil)
		  (if file
		      t
		    nil)))

(defun file-fitness (filename)
  "If the file exists, returns is size.  Otherwise, returns a large number."
  (if (file-exists-p filename)
      (with-open-file (file filename :direction :input)
		      (file-length file))
    999999999))

(defun random-elt (lst)
  (elt lst (random (length lst))))

(defun whitespace-p (ch)
  (if (member ch '(#\newline #\return #\space #\tab) :test #'equal)
      t
    nil))

(defun xor (a b)
  (or (and a (not b))
      (and (not a) b)))

(load "source/action.lisp")
(load "source/context.lisp")
(load "source/attrchar.lisp")
(load "source/sml.lisp")
(load "source/opti.lisp")
(load "source/organism.lisp")
(load "source/evolver.lisp")

;;; --- end of file ---
