;;;
;;; $Header: /home/gene/icfp2001/source/RCS/organism.lisp,v 1.2 2001/07/29 05:22:14 gene Exp $
;;;

(defstruct organism
  actions
  file-size)

(defun make-random-organism ()
  (let ((organism (make-organism))
	(action '()))
    (dotimes (i (length *meaning*))
	     (setq action (cons (random-elt *all-actions*) action)))
    (setf (organism-actions organism) action)
    organism))

(defun make-child-organism (pa pb)
  "Returns a new Organism created by mating two parent Organisms."
  (let* ((lena (length (organism-actions pa)))
	 (lenb (length (organism-actions pb)))
	 (crossover (random (min lena lenb)))
	 (child (make-organism)))
    (setf (organism-actions child)
	  (append (subseq (organism-actions pa) 0 crossover)
		  (subseq (organism-actions pb) crossover)))
    (if (zerop (random 100))
	(organism-mutate child))
    child))

(defun organism-mutate (organism)
  (when *debug* (format t "~&organism-mutate: debug: "))
  (let* ((elt (organism-actions organism))
	(count (random (length elt))))
    (dotimes (i count)
	     (setq elt (cdr elt)))
    (setf (car elt) (random-elt *all-actions*))
    (when *debug*
      (format t "~&organism-mutate: debug: (count (car elt)) (~A ~A)" count
	      (car elt)))))
			  
(defun organism-fitness (organism)
  (when (null (organism-file-size organism))
    (with-open-file (file "tmp/fitness" :direction :output
			  :if-exists :supersede)
		    (sml-print *meaning* (organism-actions organism) file)
		    (setf (organism-file-size organism) (file-length file)))
    (when (< (organism-file-size organism) (file-fitness "tmp/best"))
      (delete-file "tmp/best")
      (rename-file "tmp/fitness" "tmp/best")))
  (organism-file-size organism))
	
;;; --- end of file ---
